/*
 * usage: createClock(5, 5, "placeholderid", 0);
 */


var exClock = new Array();//global clock array
function createClock(total, remaining, placeholderId, remDivId, refreshafter, timeoutFunc, bgColor, fgColor, borderColor, finishMessage, beforeFinishTimeInSec, beforeFinishMessage)
{
	var consumed = total - remaining;
	exClock[exClock.length] = new examClock(total, consumed, placeholderId, remDivId, refreshafter, timeoutFunc, bgColor, fgColor, borderColor, finishMessage, beforeFinishTimeInSec, beforeFinishMessage);
	refreshExamClock();
}
function examClock(total, consumed, placeholderId, remDivId, refreshafter, timeoutFunc, bgColor, fgColor, borderColor, finishMessage, beforeFinishTimeInSec, beforeFinishMessage)
{
	this.started = (new Date()).getTime();
	this.absConsumedInSec = 0;
	this.totalInSec = parseInt(total);
	this.consumedInSec = parseInt(consumed);
	this.placeholderId = placeholderId;
	this.remDivId = remDivId;
	this.placeholder = AJS.$("#"+placeholderId);
	this.refreshafter = parseInt(2000);//refreshafter;
	this.divId = this.placeholderId+"_clock";
	this.width = 150;//parseInt(this.totalInSec/10); //every 10 seconds
	this.timeoutFunc = timeoutFunc;
	this.bgColor = bgColor;
	this.fgColor = fgColor;
	this.borderColor = borderColor;
	this.active = true;
	this.beforeFinishTimeInSec = 30;
	this.finishMessage = "The allocated time is finished !!!";
	this.beforeFinishMessage = null;
	this.beforeFinishWarningShown = false;
	
	if(finishMessage){
		this.finishMessage = finishMessage;
	}
	
	if(beforeFinishTimeInSec){
		this.beforeFinishTimeInSec = beforeFinishTimeInSec;
	}
	
	if(beforeFinishMessage){
		this.beforeFinishMessage = beforeFinishMessage;
	}
	
	
	if(this.bgColor == null){
		this.bgColor = "#FFFFCC";
	}
	if(this.fgColor == null){
		this.fgColor = "#FFCC00";
	}
	if(this.borderColor == null){
		this.borderColor = "#cccccc";
	}
	
	var clockContent = "<div style='width:"+this.width+"px;height:20px;background-color:"+this.bgColor+";border:1px solid "+this.borderColor+"'>"+
		"<div id='"+this.divId+"' style='text-align:center;color:#fff;width:0%;height:90%;background-color:"+this.fgColor+";border:1px solid "+this.borderColor+"'>"+
		"</div></div>";
	AJS.$("#"+placeholderId).html(clockContent);
}

function refreshExamClock()
{
	var clockSet = false;
	for(var clk=0; clk<exClock.length; clk++){
		var thisClock = exClock[clk];
		if(!thisClock.active){
			continue;
		}
		thisClock.absConsumedInSec = ( ((new Date()).getTime()) - thisClock.started  )/1000;//parseInt(thisClock.refreshafter/1000);
		var consumedTillNowInSec = parseInt(thisClock.consumedInSec + thisClock.absConsumedInSec);
		var remDiv = AJS.$("#"+thisClock.remDivId);
		var remainingMin = parseInt((thisClock.totalInSec-consumedTillNowInSec)/60.0);
		if(remainingMin < 0){
			remainingMin = 0;
		}
		var remainingSec = (thisClock.totalInSec-consumedTillNowInSec)%60;
		//alert()
		var remContent = (remainingMin<10?"0"+remainingMin:remainingMin)+":"+(remainingSec<10?"0"+remainingSec:remainingSec);
		remDiv.html(remContent);
		var cw = (remainingMin<=0?parseInt(thisClock.width):parseInt((consumedTillNowInSec*thisClock.width)/thisClock.totalInSec));
		var div = AJS.$("#"+thisClock.divId);
		div.width(cw);//relConsumed+"%";
		if(consumedTillNowInSec < thisClock.totalInSec){
			if(!clockSet){
				setTimeout("refreshExamClock()", thisClock.refreshafter);
			}
			clockSet = true;
			
			if(!thisClock.beforeFinishWarningShown && (thisClock.beforeFinishTimeInSec > 0) && ((thisClock.totalInSec - consumedTillNowInSec) <= thisClock.beforeFinishTimeInSec)){
				if(thisClock.beforeFinishMessage != null){
					thisClock.beforeFinishWarningShown = true;
					g_showInlineMessage(thisClock.beforeFinishMessage, "alarm_panel big error_panel orange_panel blue", true, false, 0, 
							20000);
				}
			}
		}
		else{
			thisClock.active = false;
			try{
				g_showInlineMessage(thisClock.finishMessage, "warning_panel big error_panel red_panel blue", true, false, 0, 10000, thisClock.timeoutFunc);
				//thisClock.timeoutFunc();
			}catch(err){alert(err);}
		}
	}
}
 
jQuery.fn.center = function () {
    this.css("position","absolute");
    this.css("top", ( AJS.$(window).height() - this.height() ) / 2+AJS.$(window).scrollTop() + "px");
    this.css("left", ( AJS.$(window).width() - this.width() ) / 2+AJS.$(window).scrollLeft() + "px");
    return this;
}


function g_hideInlineMessage(){
	AJS.$('#olt_ajax_message').fadeOut(1000);
}

function g_showInlineMessage(msg, panelClass, centered, nofade, delayInShow, showForDuration, callbackAfterFade){
	AJS.$("#olt_ajax_message").html(msg);
	AJS.$("#olt_ajax_message").removeAttr("class");
	if(centered){
		var scrollPos = g_getScrollXY();
		/*
		AJS.$("#olt_ajax_message").css("left", parseInt((screen.width - 1000) / 2)+"px");
		AJS.$("#olt_ajax_message").css("top", (scrollPos.y+200)+"px");
		*/
		AJS.$("#olt_ajax_message").center();
	}
	if(panelClass){
		AJS.$("#olt_ajax_message").addClass(panelClass);
	}else{
		AJS.$("#olt_ajax_message").addClass("error_panel grey_panel");
	}
	AJS.$("#olt_ajax_message").show();
	
	if(nofade){
		return;
	}
	
	var del = 3000;
	var dur = 10000;
	var cb = null;
	if(delayInShow){
		del = delayInShow;
	}
	if(showForDuration){
		dur = showForDuration;
	}
	if(callbackAfterFade){
		cb = callbackAfterFade;
	}
	if(del == 0){
		try{
			AJS.$('#olt_ajax_message').fadeOut(dur, cb);
	    }catch(er){}
		
	}else{
		setTimeout(function() {
	    	try{
	    		AJS.$('#olt_ajax_message').fadeOut(dur, cb);
	    	}catch(er){}
		}, delayInShow); 
	}
}

/*
  <div style="width:200;height:20;background-color:#FFFFCC;border:1px solid #ccc">
		<div style="width:10%;height:90%;background-color:red;border:1px solid #ccc">
		</div>
  </div>
*/
