/*
{
  "id": "1b33edfe-64a2-11df-9e55-f5d549eece3f",
  "status": "FINISHED",
  "student": {
    "id": "e60b4cfc-c371-11de-9a20-f44ea861ec7f"
  },
  "attempted": 0,
  "startDate": 1274423324000,
  "completedDate": 1274423344000,
  "timeRemaining": 10779696,
  "startTimeVo": 0,
  "endTimeVo": 0,
  "pauseCount": 0,
  "pausedOn": 0,
  "totalScore": 3.0,
  "noOfCorrect": 2,
  "noOfIncorrect": 3,
  "noOfUnknown": 0,
  "testInstanceQuestions": [
    {
      "testQuestionId": "92955a26-c2aa-11de-9a20-f44ea861ec7f",
      "openResp": false,
      "choices": [
        {
          "id": "9174b7ae-c2aa-11de-9a20-f44ea861ec7f"
        }
      ]
    },
    {
      "testQuestionId": "9296016a-c2aa-11de-9a20-f44ea861ec7f",
      "openResp": false,
      "choices": [
        {
          "id": "917eb178-c2aa-11de-9a20-f44ea861ec7f"
        }
      ]
    },
    {
      "testQuestionId": "92947f98-c2aa-11de-9a20-f44ea861ec7f",
      "openResp": false
    }
*/


/*
Solutions 
==========

{
  "id": "d65c447e-ed91-11de-8634-9e5f03eea367",
  "content": "\u000a\u0009\u0009\u0009<p>blah solution 1 -- - <img src=\"../att/f0172fee-b228-11df-bd10-6a83521261b4.png\" alt=\"\" /></p>\u000a\u0009\u0009",
  "testQuestionSolutions": [
    {
      "testQuestionId": "e897228a-ed91-11de-8634-9e5f03eea367",
      "content": "<p>solution text here .... </p>\u000a<h5>The sum of two numbers is 22 &amp; their difference</h5>\u000a<p><img src=\"../att/deb90d5a-b22b-11df-bd10-6a83521261b4.jpg\" alt=\"\" /></p>"
    }
  ]
}

 
 
 */
function oTestRuntime() {
	this.oTestInstance = null;
	this.timeRemainingMillis = 0;
	this.totalQuestions = 0;
	this.totalTimeSec = 0;
	this.startDate = new Date();
	this.testId = null;
	this.begin = -1;
	this.end = -1;
	this.pageSize = 1;
	this.savePending = false;
	this.requestedBegin = -1;
	this.requestedEnd = -1;
	this.testSolution = null;
	this.solutionFetched = false;
	
	this.init = function(testId, jsonArr, totalQuestions, totalTimeSec, timeRemainingMillis, begin, end, pageSize){
		this.testId = testId;
		this.oTestInstance = jsonArr;
		this.totalQuestions = totalQuestions;
		this.totalTimeSec = totalTimeSec;
		this.timeRemainingMillis = timeRemainingMillis;
		this.begin = begin;
		this.end = end;
		this.pageSize = pageSize;
		
		var warningTime = (this.totalTimeSec > 600? 300: this.totalTimeSec > 120? 120: this.totalTimeSec >= 60? 45: 30);
		var warningMsg = null;
		if(warningTime > 60){
			warningMsg = (warningTime/60)+" minutes remaining";
		}else{
			warningMsg = warningTime+" seconds remaining";
		}
		
		createClock(this.totalTimeSec, this.timeRemainingMillis/1000, "_examClock", "_examClock_rem", 0, 
				finishExamHandler, "#FFFFCC", "#FFCC00", "#cccccc", "Allocated time for the test is over!!!", 
				warningTime, warningMsg);
		
		this.updateQuestionNumbers();
		
		for(var i=0; i<this.totalQuestions; i++){
			this.setQuestionIndexStatus(i);
		}
	}
	
	this.updateQuestionNumbers = function(){
		AJS.$("#qBegin").html(this.begin+1);
		AJS.$("#qEnd").html(this.end+1);
		AJS.$("#btnPrevious").attr("disabled", !this.canGoPrevious());
		AJS.$("#btnNext").attr("disabled", !this.canGoNext());
		//section selector
		AJS.$("a.testSectionSelector").each(function(){
			if(oTestRT.begin >= parseInt(AJS.$(this).attr("begin")) 
					&& oTestRT.begin <=  parseInt(AJS.$(this).attr("end")) ){
				AJS.$(this).addClass("current");
				AJS.$(this).removeClass("tabs");
			}else{
				AJS.$(this).addClass("tabs");
				AJS.$(this).removeClass("current");
			}
		});
	}
	
	this.onQuestionChangeSR = function(elem, qIndex, chId){
		this.setSavePending();
		var prevAttempted = false;
		if(this.oTestInstance.testInstanceQuestions[qIndex].choices && this.oTestInstance.testInstanceQuestions[qIndex].choices.length > 0){
			prevAttempted = true;
		}
		
		this.oTestInstance.testInstanceQuestions[qIndex].choices = [{"id": chId}];
		if(!prevAttempted){
			this.oTestInstance.noOfAttempted++;
			this.populateCounts();
		}
		this.setQuestionIndexStatus(qIndex);
	}
	
	this.clearAnswerSR = function(qIndex){
		this.setSavePending();
		var prevAttempted = false;
		if(this.oTestInstance.testInstanceQuestions[qIndex].choices && this.oTestInstance.testInstanceQuestions[qIndex].choices.length > 0){
			prevAttempted = true;
		}
		
		if(prevAttempted){
			this.oTestInstance.testInstanceQuestions[qIndex].choices = null;
			this.oTestInstance.noOfAttempted--;
			AJS.$("input:radio[name='q_"+qIndex+"']").attr("checked", false);
			this.populateCounts();
		}
		
		this.setQuestionIndexStatus(qIndex);
	}
	
	this.onQuestionChangeMR = function(elem, qIndex, chId, totalChoices){
		this.setSavePending();
		var prevAttempted = false;
		if(this.oTestInstance.testInstanceQuestions[qIndex].choices && this.oTestInstance.testInstanceQuestions[qIndex].choices.length > 0){
			prevAttempted = true;
		}
		
		if(!prevAttempted && elem.checked){
			//initialize the array
			this.oTestInstance.testInstanceQuestions[qIndex].choices = [ ];
		}
		
		if(!elem.checked){
			//unchecked
			if(this.oTestInstance.testInstanceQuestions[qIndex].choices && this.oTestInstance.testInstanceQuestions[qIndex].choices.length > 0){
				//find if it was already selected
				for(var i=0; i<totalChoices; i++){
					if(this.oTestInstance.testInstanceQuestions[qIndex].choices[i].id==chId){
						this.oTestInstance.testInstanceQuestions[qIndex].choices.splice(i, 1);
						if(this.oTestInstance.testInstanceQuestions[qIndex].choices.length == 0){
							this.oTestInstance.noOfAttempted--;
						}
						this.populateCounts();
						break;
					}
				}
			}
		}else{
			this.oTestInstance.testInstanceQuestions[qIndex].choices.push({"id": chId});
			if(!prevAttempted){
				this.oTestInstance.noOfAttempted++;
				this.populateCounts();
			}
		}
		
		this.setQuestionIndexStatus(qIndex);
	}
	
	this.onQuestionChangeFB = function(textField, qIndex, qType){
		this.setSavePending();
		var prevAttempted = false;
		if(this.oTestInstance.testInstanceQuestions[qIndex].userResponse && AJS.$.trim(this.oTestInstance.testInstanceQuestions[qIndex].userResponse) != ""){
			prevAttempted = true;
		}
		
		this.oTestInstance.testInstanceQuestions[qIndex].userResponse = AJS.$.trim(textField.value);
		
		if(AJS.$.trim(textField.value) != ""){
			if(!prevAttempted){
				this.oTestInstance.noOfAttempted++;
				this.populateCounts();
			}
		}else{
			if(prevAttempted){
				this.oTestInstance.noOfAttempted--;
				this.populateCounts();
			}
		}
		
		this.setQuestionIndexStatus(qIndex);
	}
	
	this.onQuestionChangeST_MT_HGR_VGR = function(elem, qIndex, subQIndex, totalSubQ, totalSubQChoices, qType, chId){
		this.setSavePending();
		var prevAttempted = false;
		if(this.oTestInstance.testInstanceQuestions[qIndex].choices && this.oTestInstance.testInstanceQuestions[qIndex].choices.length > 0){
			prevAttempted = true;
		}
		
		if(!prevAttempted && elem.checked){
			//initialize the array
			this.oTestInstance.testInstanceQuestions[qIndex].choices = [ ];
		}
		
		if(!elem.checked){
			//unchecked
			if(this.oTestInstance.testInstanceQuestions[qIndex].choices && this.oTestInstance.testInstanceQuestions[qIndex].choices.length > 0){
				//find if it was already selected
				for(var i=0; i<this.oTestInstance.testInstanceQuestions[qIndex].choices.length; i++){
					if(this.oTestInstance.testInstanceQuestions[qIndex].choices[i].id==chId){
						this.oTestInstance.testInstanceQuestions[qIndex].choices.splice(i, 1);
						if(this.oTestInstance.testInstanceQuestions[qIndex].choices.length == 0){
							this.oTestInstance.noOfAttempted--;
						}
						this.populateCounts();
						return;
					}
				}
			}
		}else{
			if(qType == 'ST' || qType == 'HGR' || qType == 'VGR'){
				//remove choices corresponding to all existing for this subquestion
				AJS.$("input:radio[name='q_"+qIndex+"_"+subQIndex+"']").each(function(){
					//find if it was already selected, if yes, remove it from selection
					for(var i=0; i<oTestRT.oTestInstance.testInstanceQuestions[qIndex].choices.length; i++){
						if(oTestRT.oTestInstance.testInstanceQuestions[qIndex].choices[i].id==this.value){
							oTestRT.oTestInstance.testInstanceQuestions[qIndex].choices.splice(i, 1);
							if(oTestRT.oTestInstance.testInstanceQuestions[qIndex].choices.length == 0){
								oTestRT.oTestInstance.noOfAttempted--;
							}
							oTestRT.populateCounts();
							break;
						}
					}
				});
			}
			this.oTestInstance.testInstanceQuestions[qIndex].choices.push({"id": chId});
			if(!prevAttempted){
				this.oTestInstance.noOfAttempted++;
				this.populateCounts();
			}
		}
		
		this.setQuestionIndexStatus(qIndex);
	}
	
	this.clearAnswerST_MT_HGR_VGR = function(qIndex, totalSubQ, totalSubQChoices, qType){
		this.setSavePending();
		var prevAttempted = false;
		if(this.oTestInstance.testInstanceQuestions[qIndex].choices && this.oTestInstance.testInstanceQuestions[qIndex].choices.length > 0){
			prevAttempted = true;
		}
		
		if(prevAttempted){
			this.oTestInstance.testInstanceQuestions[qIndex].choices = null;
			this.oTestInstance.noOfAttempted--;
			if(qType == 'ST' || qType == 'HGR' || qType == 'VGR'){
				for(var i=0; i<totalSubQ; i++){
					AJS.$("input:radio[name='q_"+qIndex+"_"+i+"']").attr("checked", false);		
				}
			}else if(qType == 'MT'){
				for(var i=0; i<totalSubQ; i++){
					for(var j=0; j<totalSubQChoices; j++){
						AJS.$("input:radio[name='q_"+qIndex+"_"+i+"_"+j+"']").attr("checked", false);
					}
				}
			}
			this.populateCounts();
		}
		
		this.setQuestionIndexStatus(qIndex);
	}
	
	this.setQuestionIndexStatus = function(qIndex){
		if(this.isQuestionAnswered(qIndex)){
			AJS.$("#qi_"+qIndex).addClass("yellowbg")
			AJS.$("#qi_"+qIndex).removeClass("lightbluebg")
		}else{
			AJS.$("#qi_"+qIndex).removeClass("yellowbg")
			AJS.$("#qi_"+qIndex).removeClass("lightbluebg")
			if(qIndex >= this.begin && qIndex <= this.end){
				AJS.$("#qi_"+qIndex).addClass("lightbluebg")
			}
		}
	}
	
	this.isQuestionAnswered = function(qIndex){
		var prevAttempted = false;
		if(this.oTestInstance.testInstanceQuestions[qIndex].choices && this.oTestInstance.testInstanceQuestions[qIndex].choices.length > 0){
			prevAttempted = true;
		}else if(this.oTestInstance.testInstanceQuestions[qIndex].userResponse && AJS.$.trim(this.oTestInstance.testInstanceQuestions[qIndex].userResponse) != ""){
			prevAttempted = true;
		}
		return prevAttempted;
	}
	
	this.populateCounts = function(){
		AJS.$("#answeredCount").html(this.oTestInstance.noOfAttempted);
		AJS.$("#pendingCount").html(this.totalQuestions-this.oTestInstance.noOfAttempted);
	}
	
	this.getXmlResponseStr = function(operation){
		var xml = new Array();
		xml.push("<TestResponse testInstanceId=\""+this.oTestInstance.id+"\" saveAction=\""+operation+"\">")
		//xml.push("<questionResponses>");
		if(this.oTestInstance.testInstanceQuestions && this.oTestInstance.testInstanceQuestions.length > 0){
			for(var i=0; i<this.oTestInstance.testInstanceQuestions.length; i++){
				var tiq = this.oTestInstance.testInstanceQuestions[i];
				xml.push("<questionResponses testQuestionId=\""+tiq.testQuestionId+"\">");
				if(!tiq.openResp){
					if(tiq.choices && tiq.choices.length > 0){
						for(var j=0; j<tiq.choices.length; j++){
							xml.push("<choiceId>");
							xml.push(tiq.choices[j].id);
							xml.push("</choiceId>");
						}
					}
				}else if(tiq.userResponse){
					xml.push("<userResponse>");
					xml.push(AJS.$.trim(tiq.userResponse));
					xml.push("</userResponse>");
				}
				xml.push("</questionResponses>");
			}
		}
		//xml.push("</questionResponses>");
		xml.push("</TestResponse>");
		return xml.join('');
	}
	
	this.setSavePending = function(){
		AJS.$("#savePendingStatus").addClass("redbg");
		this.savePending = true;
	}
	
	this.resetSavePending = function(){
		AJS.$("#savePendingStatus").removeClass("redbg");
		this.savePending = false;
	}
	
	
	this.save = function(){
		this.testCommonOp("save");
		this.resetSavePending();
	}
	
	this.pause = function(){
		if(confirm("Do you want to pause the test?")){
			this.testCommonOp("pause");
		}
	}
	
	this.finish = function(forced){
		if(forced){
			this.testCommonOp("finish");
		}else{
			var confMsg = "Do you want to finish the test?";
			var pendingCount = this.totalQuestions-this.oTestInstance.noOfAttempted;
			if(pendingCount > 0){
				confMsg = "You have "+pendingCount+" questions unanswered, "+confMsg;
			}
			if(confirm(confMsg)){
				this.testCommonOp("finish");
			}
		}
	}
	
	this.testCommonOp = function(op){
		g_showInlineMessage(op+"...", "big orange_panel throbber", true, true);
		AJS.$.ajax({
			type: "post",
			url: "testInstance.action",
			data: { xmlData: this.getXmlResponseStr(op) },
			success: function(val) {
				g_hideInlineMessage();
				if(val && val.length > 0){
					var statusObj = JSON.parse(val);
					if(statusObj.status && statusObj.status == "FINISHED"){
						reloadOTest();
					}else if(statusObj.status && statusObj.status == "PAUSE"){
						reloadOTest();
					}
				}
			},
			error: function(response) {
				g_hideInlineMessage();
				oTestRT.setSavePending();
				alert("failed to save");
			}
		});
	}

	this.canGoNext = function(){
		if(this.end < this.totalQuestions-1){
			return true;
		}
		return false;
	}
	
	this.canGoPrevious = function(){
		if(this.begin > 0){
			return true;
		}
		return false;
	}
	
	this.gotoPage = function(pageNum){
		this.fetchQuestions((pageNum-1)*this.pageSize, pageNum*this.pageSize-1);
	}
	
	this.goNext = function(){
		if(this.end >= this.totalQuestions-1){
			return;
		}
		this.fetchQuestions(this.end+1, this.end+this.pageSize);
	}
	
	this.goPrevious = function(){
		if(this.begin <= 0){
			return;
		}
		this.fetchQuestions(this.begin-this.pageSize, this.begin-1);
	}
	
	this.gotoSection = function(startIndex, endIndex){
		//map startIndex to pageNum
		//this.gotoPage(startIndex/this.pageSize + 1);
		this.fetchQuestions(startIndex, startIndex+this.pageSize-1);
	}
	
	this.gotoQuestionIndex = function (qIndex){
		this.fetchQuestions(qIndex, qIndex+this.pageSize-1);
	}
	
	this.fetchQuestions = function (begin, end){
		this.requestedBegin = begin<0?0:begin;
		this.requestedEnd = end>=this.totalQuestions?this.totalQuestions-1:end;
		g_showInlineMessage("Fetching...", "big orange_panel throbber", true, true);
		AJS.$.ajax({
			type: "post",
			url: "testQuestions.action",
			data: { begin: begin+"", end: end+"", testId: oTestRT.testId },
			success: function(val) {
				g_hideInlineMessage();
				if(val && val.length > 0){
					oTestRT.loadFetchedQuestions(val);
				}
			},
			error: function(response) {
				g_hideInlineMessage();
			 alert("failed");
			}
		});
	}
	
	this.loadFetchedQuestions = function (val){
		AJS.$("#testQuestionsDiv").html(val);
		//initialize the fields
		this.begin = this.requestedBegin;
		this.end = this.requestedEnd;
		this.requestedBegin = -1;
		this.requestedEnd = -1;
		for(var i=this.begin; i<=this.end; i++){
			var tiq = this.oTestInstance.testInstanceQuestions[i];
			if(tiq.openResp == true){
				if(tiq.userResponse &&
						AJS.$.trim(tiq.userResponse) != ""){
					AJS.$("#tq_"+tiq.testQuestionId).val(AJS.$.trim(tiq.userResponse));
				}
			}else{
				if(tiq.choices && tiq.choices.length > 0){
					for(var j=0; j<tiq.choices.length; j++){
						AJS.$("#ch_"+tiq.choices[j].id).attr("checked", true);
					}
				}
			}
		}
		this.updateQuestionNumbers();
		for(var i=0; i<this.totalQuestions; i++){
			this.setQuestionIndexStatus(i);
		}
	}
	
	this.fetchSolution = function () {
		if(this.solutionFetched == true){
			return;
		}
		this.solutionFetched = true;
		g_showInlineMessage("Fetching...", "big orange_panel throbber", true, true);
		AJS.$.ajax({
			type: "post",
			url: "testSolution.action",
			async:   false,
			data: { testId: this.testId, testInstanceId: this.oTestInstance.id },
			success: function(val) {
				g_hideInlineMessage();
				if(val){
					oTestRT.testSolution = JSON.parse(val);
				}
			},
			error: function(response) {
				g_hideInlineMessage();
			 alert("failed");
			}
		});
	}
	this.getTestSolution = function(){
		if(this.solutionFetched != true){
			this.fetchSolution();
		}
		if(this.testSolution == null){
			return "No solution provided";
		}
		return this.testSolution.content;
	}
	
	this.getTestQuestionSolution = function(testQuestionId){
		if(this.solutionFetched != true){
			this.fetchSolution();
		}
		if(this.testSolution == null || this.testSolution.testQuestionSolutions == null ){
			return "No solution provided";
		}
		for(var i=0 ;i< this.testSolution.testQuestionSolutions.length; i++){
			if( this.testSolution.testQuestionSolutions[i].testQuestionId == testQuestionId){
				return this.testSolution.testQuestionSolutions[i].content;
			}
		}
		return "No solution provided";
	}
}

var oTestRT = new oTestRuntime();



